## org.apache.tomcat.jni
Class Global

    java.lang.Object
      org.apache.tomcat.jni.Global

    public class Global

extends java.lang.Object

Global

Version:
  $Revision: 467222 $, $Date: 2006-10-24 05:17:11 +0200 (Tue, 24 Oct 2006) $
Author:
  Mladen Turk

Constructor Summary
`Global()`

Method Summary
`static long` `childInit(java.lang.String fname, long pool)` Re-open a mutex in a child process.
`static long` `create(java.lang.String fname, int mech, long pool)` Create and initialize a mutex that can be used to synchronize both processes and threads.
`static int` `destroy(long mutex)` Destroy the mutex and free the memory associated with the lock.
`static int` `lock(long mutex)` Acquire the lock for the given mutex.
`static int` `trylock(long mutex)` Attempt to acquire the lock for the given mutex.
`static int` `unlock(long mutex)` Release the lock for the given mutex.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Global

    public Global()

Method Detail

### create

    public static long create(java.lang.String fname,
                              int mech,
                              long pool)
                       throws Error

  Create and initialize a mutex that can be used to synchronize both processes and threads. Note: There is considerable overhead in using this API if only cross-process or cross-thread mutual exclusion is required. See apr_proc_mutex.h and apr_thread_mutex.h for more specialized lock routines.
  Warning : Check APR_HAS_foo_SERIALIZE defines to see if the platform supports APR_LOCK_foo. Only APR_LOCK_DEFAULT is portable.

  Parameters:
    `fname` - A file name to use if the lock mechanism requires one. This argument should always be provided. The lock code itself will determine if it should be used.
    `mech` - The mechanism to use for the interprocess lock, if any; one of

                    APR_LOCK_FCNTL
                    APR_LOCK_FLOCK
                    APR_LOCK_SYSVSEM
                    APR_LOCK_POSIXSEM
                    APR_LOCK_PROC_PTHREAD
                    APR_LOCK_DEFAULT     pick the default mechanism for the platform

    `pool` - the pool from which to allocate the mutex.
  Returns:
    Newly created mutex.
  Throws:
    `Error`

### childInit

    public static long childInit(java.lang.String fname,
                                 long pool)
                          throws Error

  Re-open a mutex in a child process.

  Parameters:
    `fname` - A file name to use if the mutex mechanism requires one. This argument should always be provided. The mutex code itself will determine if it should be used. This filename should be the same one that was passed to apr_proc_mutex_create().
    `pool` - The pool to operate on. This function must be called to maintain portability, even if the underlying lock mechanism does not require it.
  Returns:
    Newly opened mutex.
  Throws:
    `Error`

### lock

    public static int lock(long mutex)

  Acquire the lock for the given mutex. If the mutex is already locked, the current thread will be put to sleep until the lock becomes available.

  Parameters:
    `mutex` - the mutex on which to acquire the lock.

### trylock

    public static int trylock(long mutex)

  Attempt to acquire the lock for the given mutex. If the mutex has already been acquired, the call returns immediately with APR_EBUSY. Note: it is important that the APR_STATUS_IS_EBUSY(s) macro be used to determine if the return value was APR_EBUSY, for portability reasons.

  Parameters:
    `mutex` - the mutex on which to attempt the lock acquiring.

### unlock

    public static int unlock(long mutex)

  Release the lock for the given mutex.

  Parameters:
    `mutex` - the mutex from which to release the lock.

### destroy

    public static int destroy(long mutex)

  Destroy the mutex and free the memory associated with the lock.

  Parameters:
    `mutex` - the mutex to destroy.

Copyright © 2000-2008 Apache Software Foundation. All Rights Reserved.